# Release Notes v0.13.0 : Event Tree Analysis

This release introduces limited and experimental support for event tree analysis.
Only necessary and sufficient functionalities are implemented
to allow the most common and basic analysis.
Moreover, the release doesn't implement any optimization specific to event-tree analysis.


## Major Changes

- Event Tree Analysis (#150)
- Event-Tree-Fault-Tree Linking (#152)
- Event-Tree Chaining (#151)
- MEF 'set-house-event' Instruction (#179)
- MEF Test-Event Expressions (#68)
- MEF Numerical Operations (#72)
- MEF Boolean Operations (#73)
- MEF Conditional Operations (#67)


## Minor Changes

- Fedora RPM Package

- Report product-order distribution (#168)

- XInclude support

- The Open-PSA MEF compliance:

    * House event state expressions are optional and can be implicitly defined to False.
    * CCF level numbers are optional.
    * CCF factors can be declared in any order.
    * Multiple 'model-data' containers are allowed within a single 'opsa-mef' element.
    * Gate formulas can have literal constant args (true, false) instead of house-events.

- Interval-based expression sample domain validation (instead of min-max)

- Print line numbers in XML schema validation error messages

- Report warning messages with XML attributes in the results-layer instead of XML elements.


## Bug Fixes

- Fail to assign a label to a pass-through gate (#166)
- Zero/One probability events (division by zero total probability) (#169)
- Segfault with single-event fault tree importance analysis with BDD (#170)
- Config: Input/output file path format is system dependent (#171)
- Config: Relative paths are not resolved wrt the config file path (#172)


## Since v0.12.0

208 commits resulted in 210 files changed, 9805 insertions(+), 3971 deletions(-)

- Core: 65 files changed, 4552 insertions(+), 2712 deletions(-)
- Scripts: 1 file changed, 18 insertions(+), 14 deletions(-)
- GUI: 2 files changed, 23 insertions(+), 94 deletions(-)
- Tests: 97 files changed, 2997 insertions(+), 557 deletions(-)
- Documentation: 23 files changed, 363 insertions(+), 352 deletions(-)
- Schemas: 4 files changed, 1119 insertions(+), 133 deletions(-)
